#include <iostream>
#include "Shape.h"
#include "Circle.h"
#include "Line.h"
#include "Rect.h"
#include "GraphicEditor.h"
#include "UI.h"
using namespace std;

GraphicEditor::GraphicEditor(){
	this->pStart=NULL;
	this->pLast = pStart;
	this->index=0;
}

void GraphicEditor::run(){
	UI::showtitle();

	while(1){
		int select;
		select = UI::showmenu();

		switch(select){
		case 1: add();
			break;
		case 2: sub();
			break;
		case 3: show();
			break;
		case 4: exit(0);
		}
	}
}

void GraphicEditor::add(){
	int shapeAdd;
	
	shapeAdd = UI::getItem();
	switch(shapeAdd){	
	case 1: this->pLast = this->pLast->add(new Line(), this->index);
		break;
	case 2: this->pLast = this->pLast->add(new Circle(), this->index);
		break;
	case 3: this->pLast = this->pLast->add(new Rect(), this->index);
		break;
	}

	this->index++;
}

void GraphicEditor::sub(){
	int shapeIndex = UI::getIndex();
	Shape* p = this->pStart;
	while(1){
		Shape* q= p->getNext();
		if(p->getIndex()==shapeIndex){
			delete p;
			p = q;
		}
		else p=p->getNext();
	}
}

void GraphicEditor::show(){
	Shape* p = this->pStart;
	while(p!=NULL){
		p->paint();
		p = p->getNext();
	}
}